;; -*- mode: scheme; coding: utf-8 -*-

;;;; Copyright (C) 2011, 2012
;;;; Free Software Foundation, Inc.
;;;;
;;;; This library is free software; you can redistribute it and/or
;;;; modify it under the terms of the GNU General Public License as
;;;; published by the Free Software Foundation; either version 3 of
;;;; the License, or (at your option) any later version.
;;;; 
;;;; This library is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;; General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with this library; if not, write to the Free Software
;;;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
;;;; 02110-1301 USA
;;;;

;;; Commentary:

;;; Code:

(define-module (system config)
  ;; common
  :use-module (system passwd)

  :export (sys/read-config
	   sys/write-config))


(define (sys/read-config aname)
  ;; opens/read ~/.config/`aname`.conf
  (let* ((udir (sys/get 'udir))
	 (cfg-filename (string-append udir "/" ".config/" aname ".conf")))
    (if (access? cfg-filename R_OK)
	(let* ((istream (open-input-file cfg-filename))
	       (line (read istream)))
	  (close istream)
	  ;; (format #t "~S~%" line)
	  line)
	#f)))

(define (sys/write-config aname what)
  (let* ((udir (sys/get 'udir))
	 (cfg-filename (string-append udir "/" ".config/" aname ".conf")))
    (let* ((ostream (open-output-file cfg-filename)))
      (format ostream "~S~%" what)
      (close ostream))))


#!

(use-modules (system config))
(reload-module (resolve-module '(system config)))
,m (system config)

(sys/read-config "kise")

(define istream (open-input-file (string-append (sys/get 'udir) "/.config/kise.conf")))
(define line (read istream))
(close istream)

!#
